#pragma once
#include "listbox.h"

#define DEFAULT_SHOWMELDUNGEN 0
class CStatusView: public VButtonWnd
{
public:
	    enum { IDD = IDD_HELP };

		CStatusView(BOOL bShowMeldung=DEFAULT_SHOWMELDUNGEN) 
    	{
			//Load Icon and BackGround
			m_pMsg = 0;
			m_nSelPos = -1;m_bMeldungen=0;
			m_pState = 0;m_nSel = -1; m_nUserStatus=-1;
	/*		if(pMsg)
			{
				m_pMsg = new TCHAR[wcslen(pMsg)+1];
				wcscpy(m_pMsg,pMsg);
			}*/
			m_bShowMeldung = bShowMeldung;
		}
		CStatusView(int icon,CRect& rect,BOOL bShowMeldung=DEFAULT_SHOWMELDUNGEN):VButtonWnd(IDB_BK_APPS,icon,rect)
    	{
			//Load Icon and BackGround
			m_pMsg = 0;
			m_nSel = -1, m_nSelPos = -1;m_bMeldungen=0;
			m_pState = 0;
	/*		if(pMsg)
			{
				m_pMsg = new TCHAR[wcslen(pMsg)+1];
				wcscpy(m_pMsg,pMsg);
			}*/
			m_szSel[0]=0;
			m_bShowMeldung = bShowMeldung;
			m_bNoCancel=0;
		}

		~CStatusView()
		{
			
			if(m_hfont) DeleteObject(m_hfont);
			//::DeleteObject(hFont);
			 if(m_pMsg) delete m_pMsg;
			 m_bNoCancel=0;
	  	}

        TCHAR           * m_pMsg;  //Msg Data
		TCHAR			m_szSel[128];
		int m_nSelPos ,m_nSel ,m_nUserStatus,m_bShowMeldung;
		BOOL m_bMeldungen;
		//__JobState * m_pState;
		int m_bNoCancel;
		void OnPaintExt(HDC hDC,CRect& rcPaint);
private:
		HFONT m_hfont;
		

		CpssScrollBar   cScrollBar;

	  //  HFONT           hFont; 
		CSimpleListCtrl   m_ListBox;// CTextEdit       m_Edit;

		

public:
	    BEGIN_MSG_MAP(CStatusView)
        MESSAGE_HANDLER(WM_INITDIALOG     ,OnInitDialog)
		MESSAGE_HANDLER(WM_ERASEBKGND ,OnErasebkgnd)
        MESSAGE_HANDLER(WM_PAINT      ,OnPaint) 
		CPSSCOM_HANDLER(ID_LIST_SEND   , BN_CLICKED,OnSendMsg)
 		CPSSCOM_HANDLER(ID_POS_MELDUNG   , BN_CLICKED,OnPosMeldung)
		MESSAGE_HANDLER(WM_TIMER, OnTimer)
		CPSSCOM_HANDLER(ID_CANCEL      , BN_CLICKED,OnCancelMsg)
        CPSSCOM_HANDLER(ID_VU_HELP      , BN_CLICKED,OnHelp)
		CPSSCOM_HANDLER(ID_SWITCH      , BN_CLICKED,OnSwitch)
		MESSAGE_HANDLER(IDB_LISTSCOLL_BK ,OnScroll)
				MESSAGE_HANDLER(WM_USER_CHANGE_SKIN,	OnChangeSkin)
		MESSAGE_HANDLER(WM_LBUTTONDOWN,	OnLButtonDown);
		MESSAGE_HANDLER(WM_LBUTTONUP,	OnLButtonUp);
		REFLECT_NOTIFICATIONS()	
		END_MSG_MAP()

protected:
	LRESULT OnInitDialog(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
	//LRESULT OnErasebkgnd(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
	//LRESULT OnPaint(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
	LRESULT OnScroll(UINT /*uMsg*/, WPARAM wParam, LPARAM /*lParam*/, BOOL& /*bHandled*/);
    LRESULT OnPosMeldung(WORD /*wNotifyCode*/, WORD wID, HWND hWndCtl, BOOL& /*bHandled*/);
	LRESULT OnSendMsg(WORD /*wNotifyCode*/, WORD wID, HWND hWndCtl, BOOL& /*bHandled*/);
LRESULT OnHelp(WORD /*wNotifyCode*/, WORD wID, HWND hWndCtl, BOOL& /*bHandled*/);
LRESULT OnSwitch(WORD /*wNotifyCode*/, WORD wID, HWND hWndCtl, BOOL& /*bHandled*/);
	LRESULT OnChangeSkin(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
	LRESULT OnCancelMsg(WORD /*wNotifyCode*/, WORD wID, HWND hWndCtl, BOOL& /*bHandled*/);
 LRESULT OnTimer(UINT /*uMsg*/, WPARAM wParam, LPARAM /*lParam*/, BOOL& /*bHandled*/);

};

int  doPosMeldung( __JobState * pState,TCHAR* szSel);
void DoMelDung( __JobState * pState,HWND hWnd,int bNoCancel=0,int nPos=-1,TCHAR* pszSel =NULL);