#include "stdafx.h"
#include "gateway.h"


HANDLE ghUDPThread ;
DWORD WINAPI udpThread(void* param) ;
#define bzero(p,s)  memset(p, 0, s)

static IN_ADDR ipMENU ; 
static  int sockfd=0; // ݶ˿
static short g_Service = 34;
void get_local_ip()
{
	struct hostent *hp;		
	 char host_name[64]="127.0.0.1";
#ifndef _ARM_
	gethostname(host_name, sizeof(host_name));
#endif
	hp = gethostbyname(host_name);
	/* Check for NULL pointer */
	if (hp )
	{
		ipMENU.S_un.S_un_b.s_b1 = hp->h_addr_list[0][0];
		ipMENU.S_un.S_un_b.s_b2 = hp->h_addr_list[0][1];
		ipMENU.S_un.S_un_b.s_b3 = hp->h_addr_list[0][2];
		ipMENU.S_un.S_un_b.s_b4 = hp->h_addr_list[0][3];
	}
}

BOOL  gw_init(HWND hWnd)
{
 DWORD err=0;
  struct sockaddr_in my_addr; // ĵַϢ
//  struct sockaddr_in their_addr; // ӶԷĵַϢ
//  int sin_size;
 // char buf[128];

  get_local_ip();
  if ((sockfd = socket(AF_INET, SOCK_DGRAM, IPPROTO_UDP)) == -1) {
   // perror("socket");
    return 0;
  }
  my_addr.sin_family = AF_INET;
  my_addr.sin_port = htons(MYPORT); // ֽ˳
  my_addr.sin_addr.s_addr = INADDR_ANY; // ԶIP
  bzero(&(my_addr.sin_zero), 8); // ಿ0
  if (bind(sockfd, (struct sockaddr *)&my_addr, sizeof(my_addr)) == -1) {
    //perror("bind");
    return 0;
  }
  DWORD dwID;
  ghUDPThread =CreateThread(NULL,0  ,udpThread ,(void*)hWnd,0, &dwID);
  return 1;
}

DWORD WINAPI udpThread(void* param) 
{
  HWND hWnd = (HWND) param;
//    struct sockaddr_in my_addr; // ĵַϢ
  struct sockaddr_in their_addr; // ӶԷĵַϢ
  int sin_size, retval;
  DWORD err = 0;
  char buf[128];
 //init_gateway();
  // ѭ
  while(1) {
	sin_size= sizeof(their_addr); 
    retval = recvfrom(sockfd, buf,128, 0, (struct sockaddr *)&their_addr, &sin_size);
    //printf("Received datagram from %s\n",inet_ntoa(their_addr.sin_addr));
    if (retval == 0) {
      //perror ("recvfrom");
      closesocket(sockfd); sockfd=-1;return 0;
      break;
    }else if(retval==-1)
	{
		err = GetLastError();
		return 0; //break;
	}
    gw_state(hWnd,buf,retval);
/*	if( is_callin(buf,retval))
	{

		PostMessage( hWnd, WM_USER_CALLIN,0,(LONG)(buf+8));
	}else if( is_call_end(buf,retval))
	{
		PostMessage( hWnd, WM_USER_CALL_END,0,0);
	}*/
  }
  return 1;
}

void gw_teardown()
{
	if(sockfd>0) 	closesocket(sockfd); 
	WaitForSingleObject(ghUDPThread,2000);
	sockfd = -1;
}

int write_gateway_file(char* msg ,int msglen)
{
	static DWORD filenum = 0;
	FILE *f;
	char szName[128];
	BOOL bOK = FALSE;
	do{
		sprintf(szName,"\\DataOverIP\\IN\\%05x" GATEWAY_EXT, filenum++);
		f = fopen(szName, "rb");
		if(f)
		{
			fclose(f);
		}else{
			bOK = TRUE; break;
		}
	}while(1);
	f = fopen(szName,"wb");
	if(f)
	{
		fwrite(msg, 1, msglen,f);
		fclose(f);
		return 0;
	}else return -1;
}

int gw_sendto(char*msg, int msglen)
{
	struct sockaddr_in their_addr; // ӶԷĵַϢ
	their_addr.sin_family = AF_INET;
	their_addr.sin_port = htons(MENUPORT); // ֽ˳
	their_addr.sin_addr.s_addr = ipMENU.S_un.S_addr; // ԶIP
	bzero(&(their_addr.sin_zero), 8); // ಿ0
	int r = sendto(sockfd,msg,msglen,0,(struct sockaddr*)(&their_addr),sizeof(their_addr));
	write_gateway_file( msg , msglen) ;
	return r;
}

int gw_recvfrom(char *msg, int maxlen)
{

	struct sockaddr_in their_addr; // ӶԷĵַϢ
	int sin_size, retval;

	sin_size= sizeof(their_addr); 
    retval = recvfrom(sockfd, msg,maxlen, 0, (struct sockaddr *)&their_addr, &sin_size);
	return retval;

}

