#include "stdafx.h"
#include "virsimplelist.h"
DWORD CVirSimpleListCtrl::DrawBK(HDC hDC)
{
	if(!m_bVisible) return 0;
	CRect rc(m_rcBound);
	//GetClientRect(&rc);
	CCanvas canvas(hDC);
	if(hListBK) canvas.BitBlt(hListBK,SRCCOPY,rc);
    return 0;
};
DWORD CVirSimpleListCtrl::DrawItem(HDC hDC ,int nLine,CRect&rcPaint)
{
	if(!m_bVisible) return 0;
	int idx = m_nStart + nLine;
	if(m_list.GetSize() <=idx) return 0;
	MYLVITEM & item = m_list[idx];
	TCHAR* bstrText;
	static FILETIME s_tmPrev={(0,0)} ;
	COLORREF clr;
	int iMode;
	int SelMark;
 	RECT rectImage;
 

	SelMark = GetSelectedIndex();
	
	HFONT hOldFont=0,hFontBold=0;


	CRect rect ,rcLine;
	GetLineRect(nLine, &rcLine);

	if( !RectInRect(rcPaint, rcLine)) return 0; 

	memcpy(&rect,&rcLine,sizeof(RECT));
	bstrText = item.pszText;
	//GetItemText(pnmtv->nmcd.dwItemSpec,pnmtv->iSubItem,bstrText);
	
//	if(rect.right > __POS_GREEN_MARK__) rect.right = __POS_GREEN_MARK__-20;
	bool Sel = ( SelMark == idx);
		
	rectImage = rect;
	rectImage.right-=rectImage.left;
	rectImage.bottom-=rectImage.top;

	CCanvas canvas(hDC);
	if (Sel)
		canvas.BitBlt(LineS.hBmp,SRCCOPY,rectImage);
#ifdef __LINE1__
	else
		canvas.BitBlt(Line1.hBmp,SRCCOPY,rectImage);
#endif

	if( SelMark == idx)
	{//&& HighlightItem == pnmtv->nmcd.lItemlParam)
		clr = ::SetTextColor(hDC,RGB(241,152,31));
	} else {
		clr = ::SetTextColor(hDC,RGB(250,250,250));
	}


	//iMode = ::SetBkMode(pnmtv->nmcd.hdc, OPAQUE);
	int style = (DT_VCENTER|DT_LEFT)|DT_END_ELLIPSIS ;
	//if(pnmtv->iSubItem==1) 	style = (DT_VCENTER|DT_LEFT) ;
	
	int nDrawLen =  wcslen(bstrText);
	TCHAR * pch = wcschr(bstrText,0xd);
	if(pch) *pch=0, nDrawLen =  wcslen(bstrText);

	iMode = SetBkMode(hDC,TRANSPARENT);
	rect.left+=m_nOff;
	CRect rcText= rect;
	int textInde = 0;
	if(m_nColWidth[0])
	{
		textInde = 6;
		rcText.right = rcText.left+ m_nColWidth[0]-textInde;
		
	}
	DrawText(hDC,bstrText, nDrawLen, &rcText, style );
	rect.left-=m_nOff;
	rcText.right += textInde ;

	
	for(int t=1;t<m_nCols;t++)
	{
		rcText.left = rcText.right+1 ;
		rcText.right=rcText.left+ m_nColWidth[t]-10; // -5 on 2016/08/05
		 
		if(item.pszTextExt[t-1])
		{
			nDrawLen =  wcslen(item.pszTextExt[t-1]);
			DrawText(hDC,item.pszTextExt[t-1], nDrawLen, &rcText, style );

		}
		if(t==1) rcText.right+=10;
	}

	::SetBkMode(hDC, iMode);
	if( SelMark ==idx)
		::SetTextColor(hDC,clr);

	//int bottom = rect.bottom;
	rect.top+=2 ; rect.left+=1;
	for(int i =0;i<3;i++)
	{
		if(item.iImages[i])
		{
			
			int nId = item.iImages[i] ;//IDB_ARROW_DELIVER;
	
			BITMAP bmp;
			CMyBitmap mybmp; 
			if(i==1) {
				rect.left=__POS_GREEN_MARK__+m_rcBound.left ;
				rect.top = rectImage.top+m_nIconOffset;
			}
			else if(i==2){
				rect.left= __POS_INFO__ +m_rcBound.left;
				rect.top = rectImage.top+m_nIconOffset;
			}else rect.top = rectImage.top+2;//4;
			
			BYTE*pBKBuf =NULL;
			 HBITMAP myh=NULL;
			 if(Sel)
			 {
				 pBKBuf=LineS.pBuf;
				 ::GetObject(LineS.hBmp, sizeof(BITMAP), &bmp);
				 myh = m_bmpMapS.Lookup(nId);
#ifdef __LINE1__
			 }		 
			 else
			 {
 
				 pBKBuf=Line1.pBuf;
				 ::GetObject(Line1.hBmp, sizeof(BITMAP), &bmp);	
				 myh = m_bmpMap.Lookup(nId);
			 }
#endif
			 int x = rect.left-rcLine.left;
			 int y = rect.top-rcLine.top;
			int hBK= bmp.bmHeight ;
			if(!myh)
			{
				LoadImageWithBK(&mybmp,nId,  x, y,pBKBuf, bmp.bmWidth,bmp.bmHeight);//SetImageTransDC(&mybmp,hDC, nId, rect.left,rect.top);
				if(Sel) m_bmpMapS.Add(nId, mybmp.m_hBitmap);
				else m_bmpMap.Add(nId, mybmp.m_hBitmap);
			}else
			{
				mybmp.m_hBitmap = myh; mybmp.m_nID = nId;
			}
			::GetObject(mybmp.m_hBitmap, sizeof(BITMAP), &bmp);
			if(y+bmp.bmHeight>=hBK)
			{	
				bmp.bmHeight=hBK-y-1;
			}
			rect.right =  bmp.bmWidth;
			rect.bottom =  bmp.bmHeight;
#ifndef __LINE1__
			}else  //if(Sel)
			{
				
				mybmp.LoadBitmap(nId,m_nIDBACK,rect.left,rect.top); 
			}
#endif
			canvas.BitBlt(mybmp,SRCCOPY,rect);
			mybmp.Detach();
		}
	}
	if(hOldFont && hFontBold)
	{
		SelectObject( hDC ,hOldFont);
		DeleteObject(hFontBold);
	}

	return  0 ;

}


void CVirSimpleListCtrl::OnPaint(HDC hDC, CRect& rcPaint)
{
	if(!m_bVisible) return ;
	int c = GetItemCount();
	if(c>0 && m_nStart>=c){
		m_nStart = (c>=4)?c-4:0;
	}
	HFONT hOld = NULL;
	if(m_hFont) hOld  =(HFONT) SelectObject(hDC, m_hFont);
	for(int i=0;i< m_nVisibleCount;i++)
	{
		DrawItem(hDC ,i,rcPaint);
	}
	if(hOld) SelectObject(hDC, hOld);
}

LRESULT CVirSimpleListCtrl::OnMouseMove(UINT, CPoint pt)
{
	if(!m_bVisible) return 0;
	if( m_rcBound.PtInRect(pt))
	{
		m_yScrollSpeed = (pt.y - m_pt.y) / SMOOTHSCROLL_SLOW_DOWN_FACTOR;
		return 1;
	}
	return 0;
}

LRESULT CVirSimpleListCtrl::OnLButtonDown(UINT, CPoint pt)
{
	if(!m_bVisible) return 0;
	// TODO: Add your message handler code here and/or call default
	if( m_rcBound.PtInRect(pt))
	{
		DWORD tick = GetTickCount();
		
		//SendMessage(m_hWnd,WM_COMMAND,m_nCmdID,0);
		int nLine = ((pt.y-m_rcBound.top)/m_nLineHeight)+m_nStart ;
		int nOld = m_nSel;
		if(nLine< m_list.GetSize())
		{
			m_nSel = nLine;
		}else m_nSel = -1;
		if(nOld!=m_nSel)
		{
			RECT rc;
			if(nOld!=-1) 
			{
				GetLineRect(nOld-m_nStart,&rc);
				InvalidateRect(m_hWnd, &rc,1);
			}
			if(m_nSel!=-1) 
			{
				GetLineRect(m_nSel-m_nStart,&rc);
				InvalidateRect(m_hWnd, &rc,1);
			}
			NMHDR lParam ;
			lParam.code = LVN_ITEMCHANGED ;
			lParam.idFrom = m_nID ;
			::SendMessage(m_hWnd, WM_NOTIFY, m_nID ,(LPARAM)&lParam);
		}
		if(tick-m_tick<0x100) 
		{
			NMHDR lParam ;
			lParam.code = NM_DBLCLK ;
			lParam.idFrom = m_nID ;
			lParam.hwndFrom = m_hWnd ;
			::SendMessage(m_hWnd, WM_NOTIFY, m_nID ,(LPARAM)&lParam);
		}
		m_tick =tick;
		m_pt = pt;m_yScrollSpeed= 0;
		if(m_nTimer!=-1) KillTimer(m_hWnd, m_nTimer);
		m_nTimer=SetTimer(m_hWnd, SMOOTHSCROLL_TIMER_ID, SMOOTHSCROLL_DELAY_IN_MS, NULL);
		return 1;
	}
	return 0;
}

LRESULT CVirSimpleListCtrl::OnLButtonUp(UINT, CPoint pt)
{
	if(!m_bVisible) return 0;
	LRESULT r = 0;
	if( m_rcBound.PtInRect(pt))
	{
		if(abs(m_yScrollSpeed)>3&&m_nTimer!=-1 )
		{
			int wParam =  m_yScrollSpeed<0 ;
			m_yScrollSpeed = 0;
			::SendMessage(m_hWnd, IDB_LISTSCOLL_BK, wParam,m_nVisibleCount+1);
		}
		m_yScrollSpeed = 0;
		r = 1;
	}
	if(m_nTimer!=-1) KillTimer(m_hWnd, m_nTimer);m_nTimer=-1;
//	SetPressed(FALSE);
	return r;
}

void CVirSimpleListCtrl::OnTimer(WPARAM wParam)
{
	if(!m_bVisible) return ;
	if(wParam==m_nTimer) 
	{
		//KillTimer(m_hWnd, SMOOTHSCROLL_TIMER_ID);
		if(abs(m_yScrollSpeed)>3 )
		{
			int wParam =  m_yScrollSpeed<0 ;
			m_yScrollSpeed = 0;
			if(m_nTimer!=-1) KillTimer(m_hWnd, m_nTimer);m_nTimer=-1;
			::SendMessage(m_hWnd, IDB_LISTSCOLL_BK,wParam,m_nVisibleCount+1);
		}
		m_yScrollSpeed= 0;
	}
	
}


LRESULT CVirSimpleListCtrl::OnScroll( WPARAM wParam, LPARAM lParam)
{

	UINT nCount = GetItemCount();
	int SelMark,PrevSel;
	//int p_Rect[4]={0,31,62,93};
	SelMark = GetSelectedIndex();
	PrevSel = SelMark;

	//Scroll(sz);
	if(wParam==0){
		//SendMessage(WM_VSCROLL,  SB_LINEUP,   0);
		if(SelMark >0  ){
			if(lParam==0) SelMark--;
			else  SelMark-=lParam ;
			if(SelMark<0) SelMark = 0;
		}else return 0;
	}else {
		//SendMessage(WM_VSCROLL,  SB_LINEDOWN,   0);
		if(SelMark < (nCount-1)){
			if(lParam==0) SelMark++;
			else  SelMark+=lParam;
			if(SelMark>=nCount) SelMark = nCount-1;
		}else return 0;
	}
//////////////////////////////////////////////
		int bInv=FALSE;
		if(lParam==0)
		{
			CRect rc(m_rcBound);
			int dy = m_nLineHeight;
			if(wParam==0)
			{
				if(PrevSel==m_nStart)	 //if(PrevSel==m_nStart+1)	
				{
					rc.top+=m_nLineHeight;
					::ScrollWindowEx(m_hWnd,0,dy,&rc,&rc,NULL,NULL,0);
					GetLineRect(0,&rc);rc.bottom+=m_nLineHeight;
					rc.left=0;
					::InvalidateRect(m_hWnd, &rc,1);
					bInv = TRUE;
				}
			}else
			{
				if(PrevSel==m_nStart+m_nVisibleCount-1)	//if(PrevSel==m_nStart+m_nVisibleCount-2)	
				{
					rc.bottom-=m_nLineHeight;
					::ScrollWindowEx(m_hWnd,0,-dy,&rc,&rc,NULL,NULL,0);
					GetLineRect(m_nVisibleCount-1,&rc);rc.top-=m_nLineHeight;
					rc.left=0;::InvalidateRect(m_hWnd, &rc,1);
					bInv = TRUE;
				}
			}
		}
///////////////////////////////////////////
#ifdef __VIR_LIST__
	EnsureVisible(SelMark);
#endif
	if(PrevSel!=SelMark){
		
		BOOL bNotify = FALSE;
		if(PrevSel==0 || SelMark==0 ||   SelMark == (nCount-1) || PrevSel == (nCount-1) )
			bNotify = TRUE;
		SelectItem(SelMark,bNotify|m_bForceNotify);


///////////////////////////////////////////
	//	if(!bInv)
///////////////////////////////////////////
		Invalidate();
		//UpdateWindow();
		
	}
	return 0;
}